#include <bits/stdc++.h>
#define ll long long
using namespace std;
int main()
{
    ios::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
    int n,c,q;
    cin>>n>>c>>q;
    string s;
    cin>>s;
    if(c==n)
    for(int i1=0;i1<q;i1++)
    {
        int l,r,b1=0,b0=0;
        cin>>l>>r;
        l--,r--;
        for(int i=l;i<=r;i++)
            if(s[i]=='1') s[i]='0';
            else s[i]='1';
        for(int i=0;i<n;i++)
            if(s[i]=='1') b1++;
            else b0++;
        if(b0>=b1) cout<<b1<<"\n";
        else
        {
            if(c+b0<b1) cout<<c+b0<<"\n";
            else cout<<b1<<"\n";
        }
    }
    else
    {for(int i1=0;i1<q;i1++)
    {
        int l,r;
        cin>>l>>r;
        l--,r--;
        for(int i=l;i<=r;i++)
            if(s[i]=='1') s[i]='0';
            else s[i]='1';
        int br=0;
        for(int i=0;i<n;i++)
        {
            if((i=0&&s[i]=='1')||(s[i-1]=='0'&&s[i]=='1'))br++;
        }
        cout<<br;
    }}
}